3 # $Id: configure,v 1.65 2018/02/27 11:16:23 schwarze Exp $
5 # Copyright (c) 2014, 2015, 2016, 2017 Ingo Schwarze <schwarze@openbsd.org>
7 # Permission to use, copy, modify, and distribute this software for any
8 # purpose with or without fee is hereby granted, provided that the above
9 # copyright notice and this permission notice appear in all copies.
11 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
12 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
13 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
14 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
15 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
16 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
17 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
21 [ -w config.log
] && mv config.log config.log.old
22 [ -w config.h
] && mv config.h config.h.old
24 # Output file descriptor usage:
25 # 1 (stdout): config.h, Makefile.local
26 # 2 (stderr): original stderr, usually to the console
30 echo "config.log: writing..."
32 # --- default settings -------------------------------------------------
33 # Initialize all variables here,
34 # such that nothing can leak in from the environment.
36 SOURCEDIR
=`dirname "$0"`
38 MANPATH_BASE
="/usr/share/man:/usr/X11R6/man"
39 MANPATH_DEFAULT
="/usr/share/man:/usr/X11R6/man:/usr/local/man"
43 CC
=`printf "all:\\n\\t@echo \\\$(CC)\\n" | env -i make -sf -`
44 CFLAGS
="-g -W -Wall -Wmissing-prototypes -Wstrict-prototypes -Wwrite-strings"
45 CFLAGS
="${CFLAGS} -Wno-unused-parameter"
64 HAVE_FTS_COMPARE_CONST
=
107 BINM_APROPOS
="apropos"
109 BINM_MAKEWHATIS
="makewhatis"
114 MANM_MANCONF
="man.conf"
127 # --- manual settings from configure.local -----------------------------
129 if [ -r .
/configure.
local ]; then
130 echo "configure.local: reading..." 1>&2
131 echo "configure.local: reading..." 1>&3
132 cat .
/configure.
local 1>&3
135 echo "configure.local: no (fully automatic configuration)" 1>&2
136 echo "configure.local: no (fully automatic configuration)" 1>&3
140 # --- tests for config.h ----------------------------------------------
142 COMP
="${CC} ${CFLAGS} -Wno-unused -Werror"
144 # Check whether this HAVE_ setting is manually overridden.
145 # If yes, use the override, if no, do not decide anything yet.
146 # Arguments: lower-case test name, manual value
148 [ -z "${3}" ] && return 1
149 echo "${1}: manual (HAVE_${2}=${3})" 1>&2
150 echo "${1}: manual (HAVE_${2}=${3})" 1>&3
155 # Run a single autoconfiguration test.
156 # In case of success, enable the feature.
157 # In case of failure, do not decide anything yet.
158 # Arguments: lower-case test name, upper-case test name, additional CFLAGS
160 cat 1>&3 << __HEREDOC__
162 ${COMP} -o test-${1} test-${1}.c ${3}
165 if ${COMP} -o "test-${1}" "${SOURCEDIR}/test-${1}.c" ${3} 1>&3 2>&3
167 echo "${1}${3}: ${CC} succeeded" 1>&3
169 echo "${1}${3}: ${CC} failed with $?" 1>&3
174 if .
/test-${1} 1>&3 2>&3; then
175 echo "${1}${3}: yes" 1>&2
176 echo "${1}${3}: yes" 1>&3
182 echo "${1}${3}: execution failed with $?" 1>&3
189 # Run a complete autoconfiguration test, including the check for
190 # a manual override and disabling the feature on failure.
191 # Arguments: lower case name, upper case name, additional CFLAGS
193 eval _manual
=\
${HAVE_${2}}
194 ismanual
"${1}" "${2}" "${_manual}" && return 0
195 singletest
"${1}" "${2}" "${3}" && return 0
196 echo "${1}${3}: no" 1>&2
201 # Select a UTF-8 locale.
203 [ -n "${HAVE_WCHAR}" ] && [ "${HAVE_WCHAR}" -eq 0 ] && return 0
204 ismanual UTF8_LOCALE UTF8_LOCALE
"$UTF8_LOCALE" && return 0
205 echo "UTF8_LOCALE: testing..." 1>&3
206 UTF8_LOCALE
=`locale -a | grep -i '^en_US\.UTF-*8$' | head -n 1`
207 if [ -z "${UTF8_LOCALE}" ]; then
208 UTF8_LOCALE
=`locale -a | grep -i '\.UTF-*8' | head -n 1`
209 [ -n "${UTF8_LOCALE}" ] || return 1
211 echo "UTF8_LOCALE=${UTF8_LOCALE}" 1>&2
212 echo "UTF8_LOCALE=${UTF8_LOCALE}" 1>&3
218 # --- library functions ---
219 runtest dirent
-namlen DIRENT_NAMLEN
|| true
220 runtest be32toh ENDIAN
|| true
221 runtest be32toh SYS_ENDIAN
-DSYS_ENDIAN || true
222 runtest EFTYPE EFTYPE
|| true
223 runtest err ERR
|| true
224 runtest getline GETLINE
|| true
225 runtest getsubopt GETSUBOPT
|| true
226 runtest isblank ISBLANK
|| true
227 runtest mkdtemp MKDTEMP
|| true
228 runtest ntohl NTOHL
|| true
229 runtest O_DIRECTORY O_DIRECTORY
|| true
230 runtest PATH_MAX PATH_MAX
|| true
231 runtest pledge PLEDGE
|| true
232 runtest sandbox_init SANDBOX_INIT
|| true
233 runtest progname PROGNAME
|| true
234 runtest reallocarray REALLOCARRAY
|| true
235 runtest recallocarray RECALLOCARRAY
|| true
236 runtest rewb
-bsd REWB_BSD
|| true
237 runtest rewb
-sysv REWB_SYSV
|| true
238 runtest strcasestr STRCASESTR
|| true
239 runtest stringlist STRINGLIST
|| true
240 runtest strlcat STRLCAT
|| true
241 runtest strlcpy STRLCPY
|| true
242 runtest strndup STRNDUP
|| true
243 runtest strptime STRPTIME
|| true
244 runtest strsep STRSEP
|| true
245 runtest strtonum STRTONUM
|| true
246 runtest vasprintf VASPRINTF
|| true
248 if [ ${HAVE_ENDIAN} -eq 0 -a \
249 ${HAVE_SYS_ENDIAN} -eq 0 -a \
250 ${HAVE_NTOHL} -eq 0 ]; then
251 echo "FATAL: no endian conversion functions found" 1>&2
252 echo "FATAL: no endian conversion functions found" 1>&3
256 if ismanual fts FTS
${HAVE_FTS}; then
257 HAVE_FTS_COMPARE_CONST
=0
258 elif runtest fts FTS_COMPARE_CONST
-DFTS_COMPARE_CONST; then
261 runtest fts FTS
|| true
264 # --- wide character and locale support ---
266 runtest wchar WCHAR
-DUTF8_LOCALE=\"${UTF8_LOCALE}\" || true
269 echo "wchar: no (no UTF8_LOCALE)" 1>&2
270 echo "wchar: no (no UTF8_LOCALE)" 1>&3
274 if [ -n "${LD_NANOSLEEP}" ]; then
275 runtest nanosleep NANOSLEEP
"${LD_NANOSLEEP}" || true
276 elif singletest nanosleep NANOSLEEP
; then
278 elif runtest nanosleep NANOSLEEP
"-lrt"; then
281 if [ "${HAVE_NANOSLEEP}" -eq 0 ]; then
282 echo "FATAL: nanosleep: no" 1>&2
283 echo "FATAL: nanosleep: no" 1>&3
287 if [ ${BUILD_CATMAN} -gt 0 ]; then
289 if [ -n "${LD_RECVMSG}" ]; then
290 runtest recvmsg RECVMSG
"${LD_RECVMSG}" || true
291 elif singletest recvmsg RECVMSG
; then
293 elif runtest recvmsg RECVMSG
"-lsocket"; then
294 LD_RECVMSG
="-lsocket"
296 if [ "${HAVE_RECVMSG}" -eq 0 ]; then
297 echo "FATAL: recvmsg: no" 1>&2
298 echo "FATAL: recvmsg: no" 1>&3
299 echo "Without recvmsg(2), you cannot BUILD_CATMAN." 1>&2
304 if singletest cmsg CMSG
; then
306 elif runtest cmsg CMSG
"-D_XPG4_2"; then
309 if [ "${HAVE_CMSG}" -eq 0 ]; then
310 echo "FATAL: cmsg: no" 1>&2
311 echo "FATAL: cmsg: no" 1>&3
312 echo "Without CMSG_FIRSTHDR(3), you cannot BUILD_CATMAN." 1>&2
318 if ismanual ohash OHASH
"${HAVE_OHASH}"; then
320 elif [ -n "${LD_OHASH}" ]; then
321 runtest ohash OHASH
"${LD_OHASH}" || true
322 elif singletest ohash OHASH
; then
324 elif runtest ohash OHASH
"-lutil"; then
327 if [ "${HAVE_OHASH}" -eq 0 ]; then
332 LDADD
="${LDADD} ${LD_NANOSLEEP} ${LD_RECVMSG} ${LD_OHASH} -lz"
333 echo "LDADD=\"${LDADD}\"" 1>&2
334 echo "LDADD=\"${LDADD}\"" 1>&3
337 # --- write config.h ---
343 #error "Do not use C++. See the INSTALL file."
346 #if !defined(__GNUC__) || (__GNUC__ < 4)
347 #define __attribute__(x)
350 #if defined(__linux__) || defined(__MINT__)
351 #define _GNU_SOURCE /* See test-*.c what needs this. */
356 [ ${HAVE_GETLINE} -eq 0 -o \
357 ${HAVE_REALLOCARRAY} -eq 0 -o ${HAVE_RECALLOCARRAY} -eq 0 -o \
358 ${HAVE_STRLCAT} -eq 0 -o ${HAVE_STRLCPY} -eq 0 -o \
359 ${HAVE_STRNDUP} -eq 0 ] \
360 && echo "#include <sys/types.h>"
361 [ ${HAVE_VASPRINTF} -eq 0 ] && echo "#include <stdarg.h>"
362 [ ${HAVE_GETLINE} -eq 0 ] && echo "#include <stdio.h>"
365 echo "#define MAN_CONF_FILE \"/etc/${MANM_MANCONF}\""
366 echo "#define MANPATH_BASE \"${MANPATH_BASE}\""
367 echo "#define MANPATH_DEFAULT \"${MANPATH_DEFAULT}\""
368 [ -n "${OSNAME}" ] && echo "#define OSNAME \"${OSNAME}\""
369 [ -n "${UTF8_LOCALE}" ] && echo "#define UTF8_LOCALE \"${UTF8_LOCALE}\""
370 [ -n "${HOMEBREWDIR}" ] && echo "#define HOMEBREWDIR \"${HOMEBREWDIR}\""
371 [ ${HAVE_EFTYPE} -eq 0 ] && echo "#define EFTYPE EINVAL"
372 [ ${HAVE_O_DIRECTORY} -eq 0 ] && echo "#define O_DIRECTORY 0"
373 [ ${HAVE_PATH_MAX} -eq 0 ] && echo "#define PATH_MAX 4096"
374 if [ ${HAVE_ENDIAN} -eq 0 -a ${HAVE_SYS_ENDIAN} -eq 0 ]; then
375 echo "#define be32toh ntohl"
376 echo "#define htobe32 htonl"
380 #define HAVE_CMSG_XPG42 ${HAVE_CMSG_XPG42}
381 #define HAVE_DIRENT_NAMLEN ${HAVE_DIRENT_NAMLEN}
382 #define HAVE_ENDIAN ${HAVE_ENDIAN}
383 #define HAVE_ERR ${HAVE_ERR}
384 #define HAVE_FTS ${HAVE_FTS}
385 #define HAVE_FTS_COMPARE_CONST ${HAVE_FTS_COMPARE_CONST}
386 #define HAVE_GETLINE ${HAVE_GETLINE}
387 #define HAVE_GETSUBOPT ${HAVE_GETSUBOPT}
388 #define HAVE_ISBLANK ${HAVE_ISBLANK}
389 #define HAVE_MKDTEMP ${HAVE_MKDTEMP}
390 #define HAVE_NTOHL ${HAVE_NTOHL}
391 #define HAVE_PLEDGE ${HAVE_PLEDGE}
392 #define HAVE_PROGNAME ${HAVE_PROGNAME}
393 #define HAVE_REALLOCARRAY ${HAVE_REALLOCARRAY}
394 #define HAVE_RECALLOCARRAY ${HAVE_RECALLOCARRAY}
395 #define HAVE_REWB_BSD ${HAVE_REWB_BSD}
396 #define HAVE_REWB_SYSV ${HAVE_REWB_SYSV}
397 #define HAVE_SANDBOX_INIT ${HAVE_SANDBOX_INIT}
398 #define HAVE_STRCASESTR ${HAVE_STRCASESTR}
399 #define HAVE_STRINGLIST ${HAVE_STRINGLIST}
400 #define HAVE_STRLCAT ${HAVE_STRLCAT}
401 #define HAVE_STRLCPY ${HAVE_STRLCPY}
402 #define HAVE_STRNDUP ${HAVE_STRNDUP}
403 #define HAVE_STRPTIME ${HAVE_STRPTIME}
404 #define HAVE_STRSEP ${HAVE_STRSEP}
405 #define HAVE_STRTONUM ${HAVE_STRTONUM}
406 #define HAVE_SYS_ENDIAN ${HAVE_SYS_ENDIAN}
407 #define HAVE_VASPRINTF ${HAVE_VASPRINTF}
408 #define HAVE_WCHAR ${HAVE_WCHAR}
409 #define HAVE_OHASH ${HAVE_OHASH}
411 #define BINM_APROPOS "${BINM_APROPOS}"
412 #define BINM_CATMAN "${BINM_CATMAN}"
413 #define BINM_MAKEWHATIS "${BINM_MAKEWHATIS}"
414 #define BINM_MAN "${BINM_MAN}"
415 #define BINM_SOELIM "${BINM_SOELIM}"
416 #define BINM_WHATIS "${BINM_WHATIS}"
420 if [ ${HAVE_ERR} -eq 0 ]; then
421 echo "extern void err(int, const char *, ...);"
422 echo "extern void errx(int, const char *, ...);"
423 echo "extern void warn(const char *, ...);"
424 echo "extern void warnx(const char *, ...);"
427 [ ${HAVE_GETLINE} -eq 0 ] && \
428 echo "extern ssize_t getline(char **, size_t *, FILE *);"
430 [ ${HAVE_GETSUBOPT} -eq 0 ] && \
431 echo "extern int getsubopt(char **, char * const *, char **);"
433 [ ${HAVE_ISBLANK} -eq 0 ] && \
434 echo "extern int isblank(int);"
436 [ ${HAVE_MKDTEMP} -eq 0 ] && \
437 echo "extern char *mkdtemp(char *);"
439 if [ ${HAVE_PROGNAME} -eq 0 ]; then
440 echo "extern const char *getprogname(void);"
441 echo "extern void setprogname(const char *);"
444 [ ${HAVE_REALLOCARRAY} -eq 0 ] && \
445 echo "extern void *reallocarray(void *, size_t, size_t);"
447 [ ${HAVE_RECALLOCARRAY} -eq 0 ] && \
448 echo "extern void *recallocarray(void *, size_t, size_t, size_t);"
450 [ ${HAVE_STRCASESTR} -eq 0 ] && \
451 echo "extern char *strcasestr(const char *, const char *);"
453 [ ${HAVE_STRLCAT} -eq 0 ] && \
454 echo "extern size_t strlcat(char *, const char *, size_t);"
456 [ ${HAVE_STRLCPY} -eq 0 ] && \
457 echo "extern size_t strlcpy(char *, const char *, size_t);"
459 [ ${HAVE_STRNDUP} -eq 0 ] && \
460 echo "extern char *strndup(const char *, size_t);"
462 [ ${HAVE_STRSEP} -eq 0 ] && \
463 echo "extern char *strsep(char **, const char *);"
465 [ ${HAVE_STRTONUM} -eq 0 ] && \
466 echo "extern long long strtonum(const char *, long long, long long, const char **);"
468 [ ${HAVE_VASPRINTF} -eq 0 ] && \
469 echo "extern int vasprintf(char **, const char *, va_list);"
471 echo "config.h: written" 1>&2
472 echo "config.h: written" 1>&3
474 # --- tests for Makefile.local -----------------------------------------
476 exec > Makefile.
local
478 [ -z "${BINDIR}" ] && BINDIR
="${PREFIX}/bin"
479 [ -z "${SBINDIR}" ] && SBINDIR
="${PREFIX}/sbin"
480 [ -z "${BIN_FROM_SBIN}" ] && BIN_FROM_SBIN
="../bin"
481 [ -z "${INCLUDEDIR}" ] && INCLUDEDIR
="${PREFIX}/include/mandoc"
482 [ -z "${LIBDIR}" ] && LIBDIR
="${PREFIX}/lib/mandoc"
483 [ -z "${MANDIR}" ] && MANDIR
="${PREFIX}/man"
485 [ -z "${HTDOCDIR}" ] && HTDOCDIR
="${WWWPREFIX}/htdocs"
486 [ -z "${CGIBINDIR}" ] && CGIBINDIR
="${WWWPREFIX}/cgi-bin"
488 [ -z "${INSTALL_PROGRAM}" ] && INSTALL_PROGRAM
="${INSTALL} -m 0555"
489 [ -z "${INSTALL_LIB}" ] && INSTALL_LIB
="${INSTALL} -m 0444"
490 [ -z "${INSTALL_MAN}" ] && INSTALL_MAN
="${INSTALL} -m 0444"
491 [ -z "${INSTALL_DATA}" ] && INSTALL_DATA
="${INSTALL} -m 0444"
494 [ ${BUILD_CGI} -gt 0 ] && BUILD_TARGETS
="man.cgi"
495 [ ${BUILD_CATMAN} -gt 0 ] && \
496 BUILD_TARGETS
="${BUILD_TARGETS} mandocd catman"
498 [ ${INSTALL_LIBMANDOC} -gt 0 ] && INSTALL_TARGETS
="lib-install"
499 [ ${BUILD_CGI} -gt 0 ] && INSTALL_TARGETS
="${INSTALL_TARGETS} cgi-install"
500 [ ${BUILD_CATMAN} -gt 0 ] && \
501 INSTALL_TARGETS
="${INSTALL_TARGETS} catman-install"
504 BUILD_TARGETS = ${BUILD_TARGETS}
505 INSTALL_TARGETS = ${INSTALL_TARGETS}
514 BIN_FROM_SBIN = ${BIN_FROM_SBIN}
515 INCLUDEDIR = ${INCLUDEDIR}
518 WWWPREFIX = ${WWWPREFIX}
519 HTDOCDIR = ${HTDOCDIR}
520 CGIBINDIR = ${CGIBINDIR}
521 BINM_APROPOS = ${BINM_APROPOS}
522 BINM_CATMAN = ${BINM_CATMAN}
523 BINM_MAKEWHATIS = ${BINM_MAKEWHATIS}
524 BINM_MAN = ${BINM_MAN}
525 BINM_SOELIM = ${BINM_SOELIM}
526 BINM_WHATIS = ${BINM_WHATIS}
527 MANM_MAN = ${MANM_MAN}
528 MANM_MANCONF = ${MANM_MANCONF}
529 MANM_MDOC = ${MANM_MDOC}
530 MANM_ROFF = ${MANM_ROFF}
531 MANM_EQN = ${MANM_EQN}
532 MANM_TBL = ${MANM_TBL}
534 INSTALL_PROGRAM = ${INSTALL_PROGRAM}
535 INSTALL_LIB = ${INSTALL_LIB}
536 INSTALL_MAN = ${INSTALL_MAN}
537 INSTALL_DATA = ${INSTALL_DATA}
541 echo "Makefile.local: written" 1>&2
542 echo "Makefile.local: written" 1>&3